## openssl 3.4.0

=== debian/changelog ===
openssl (3.4.0-1ubuntu2) plucky; urgency=medium

  * d/p/fips/crypto-Automatically-use-the-FIPS-provider-when-the-kerne.patch:
    Extend the patch to print the error encounted when a fallback
    provider fails loading, e.g. due to FIPS auto-loading (LP: #2066990)
  * d/p/Revert-When-defining-ossl_ssize_t-ssize_t-remember-t.patch:
    Work-around SWIG using different feature flag defines than GCC and
    parsing sys/select.h differently. (LP: #2091883)

 -- Adrien Nader <adrien.nader@canonical.com>  Thu, 19 Dec 2024 16:12:42 +0100

openssl (3.4.0-1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable (LP: #2044795). Remaining changes:
    - Use perl:native in the autopkgtest for installability on i386.
    - Symlink copyright/changelog.Debian.gz in libssl3* to libssl-dev/openssl
    - Disable LTO with which the codebase is generally incompatible (LP: #2058017)
    - Default config reads crypto-config and /etc/ssl/openssl.cnf.d dropins
    - patch: crypto: Add kernel FIPS mode detection
    - patch: crypto: Automatically use the FIPS provider...
    - patch: apps/speed: Omit unavailable algorithms in FIPS mode
    - patch: apps: pass -propquery arg to the libctx DRBG fetches
    - patch: test: Ensure encoding runs with the correct context...
    - patch: Add Ubuntu-specific defines to help FIPS certification (LP: #2073991)
      + UBUNTU_OSSL_SELF_TEST_DESC_PCT_DH
      + UBUNTU_OSSL_PROV_FIPS_PARAM_UNAPPROVED_USAGE
    Dropped, merged upstream:
    - debian/patches/CVE-2024-6119.patch: avoid type errors in EAI-related
      name check logic in crypto/x509/v3_utl.c, test/*.
  * Don't enable or package anything FIPS (LP: #2087955)

 -- Adrien Nader <adrien.nader@canonical.com>  Fri, 29 Nov 2024 11:19:56 +0100

openssl (3.4.0-1) experimental; urgency=medium

  * Import 3.4.0

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 23 Oct 2024 21:18:43 +0200

openssl (3.4.0~~beta1-2) experimental; urgency=medium

  * Add a patch to avoid using other memory allocations if custom malloc is
    provided.
  * Add a patch to check length in the SPARC assembly implementation of
    AES-CBC.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sun, 13 Oct 2024 22:07:10 +0200

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian.rules file - for GNU Hello (1.3).
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified
#
# Modified to be a prototype for debmake by Christoph Lameter <clameter@debian.org>
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs optimize=-lto

SHELL=/bin/bash

package=openssl
library_package=libssl3t64

# For generating the manpages
export VERSION=$(DEB_VERSION_UPSTREAM)

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	export CROSS_COMPILE ?= $(DEB_HOST_GNU_TYPE)-
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

CONFARGS  = --prefix=/usr --openssldir=/usr/lib/ssl --libdir=lib/$(DEB_HOST_MULTIARCH) no-idea no-mdc2 no-rc5 no-ssl3 enable-unit-test no-ssl3-method enable-rfc3779 enable-cms no-capieng no-rdrand \
	    enable-tfo enable-zstd enable-zlib no-fips
#OPT_alpha = ev4 ev5
ARCHOPTS  = OPT_$(DEB_HOST_ARCH)
OPTS      = $($(ARCHOPTS))

ifeq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
	TESTSUITE_FLAGS = HARNESS_VERBOSE=yes
else
	TESTSUITE_FLAGS =
endif

ifneq ($(filter amd64 arm64 ppc64el riscv64,$(DEB_HOST_ARCH_CPU)),)
	CONFARGS += enable-ec_nistp_64_gcc_128
endif

%:
	dh $@ --without autoreconf

override_dh_auto_configure:
	test -z "$(OPTS)" || for opt in $(OPTS); \
	do \
		set -xe; \
		mkdir build_$$opt; \
		cd build_$$opt ; \
		../Configure shared $(CONFARGS) debian-$(DEB_HOST_ARCH)-$$opt; \
		perl configdata.pm -d; \
		cd .. ;\
	done
	# Debian Perl policy 5.1 (Script Magic)
	mkdir build_shared; cd build_shared; HASHBANGPERL=/usr/bin/perl ../Configure shared $(CONFARGS) debian-$(DEB_HOST_ARCH) ;perl configdata.pm -d

override_dh_auto_build-indep:
	$(MAKE) -C build_shared all

override_dh_auto_build-arch:
	test -z "$(OPTS)" || for opt in $(OPTS); \
	do \
		set -xe; \
		$(MAKE) -C build_$$opt all; \
	done
	ln -sf apps/openssl.pod crypto/crypto.pod ssl/ssl.pod doc/
	$(MAKE) -C build_shared all

override_dh_auto_test-indep:

override_dh_auto_test-arch:
ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	@echo Skipping tests
else
	test -z "$(OPTS)" || for opt in $(OPTS); \
	do \
		set -xe; \
		$(MAKE) -C build_$$opt test $(TESTSUITE_FLAGS); \
	done
	$(MAKE) -C build_shared test $(TESTSUITE_FLAGS)
endif

override_dh_auto_clean:
	rm -rf build_shared
	test -z "$(OPTS)" || for opt in $(OPTS); \
	do \
		set -xe; \
		rm -rf build_$$opt; \
	done
	rm -f doc/openssl.pod doc/crypto.pod doc/ssl.pod
	dh_auto_clean

override_dh_auto_install-indep:
	# Install is only required for the -indep only build, that is if
	# -arch isn't run as well. Otherwise install will fail because
	# usr/lib/ssl/cert is a symlink to a non existing target.
	if [ ! -L debian/tmp/usr/lib/ssl/certs ]; then \
		$(MAKE) -C build_shared install DESTDIR=`pwd`/debian/tmp ;\
		mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl ;\
		mv debian/tmp/usr/include/openssl/opensslconf.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl/ ;\
		mv debian/tmp/usr/include/openssl/configuration.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl/ ;\
	fi

override_dh_auto_install-arch:
	$(MAKE) -C build_shared install DESTDIR=`pwd`/debian/tmp
	# pic static libraries, nobody should need them
	cp -pf build_shared/libcrypto.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcrypto.a
	cp -pf build_shared/libssl.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libssl.a
	mkdir -p debian/tmp/etc/ssl
	mv debian/tmp/usr/lib/ssl/{certs,openssl.cnf,private} debian/tmp/etc/ssl/
	ln -s /etc/ssl/{certs,openssl.cnf,private} debian/tmp/usr/lib/ssl/
	ln -s /etc/ssl/certs/ca-certificates.crt debian/tmp/usr/lib/ssl/cert.pem
ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
	cp -pf debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcrypto.so.* debian/libcrypto3-udeb/usr/lib/
	cp -pf debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/ossl-modules/*.so debian/libcrypto3-udeb/usr/lib/ossl-modules
	cp -pf debian/tmp/etc/ssl/openssl.cnf debian/libcrypto3-udeb/usr/lib/ssl/openssl.cnf
	cp -pf debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libssl.so.* debian/libssl3-udeb/usr/lib/
endif
	cp -auv build_shared/lib*.so* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	for opt in $(OPTS); \
		do set -xe; \
		mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/$$opt; \
		cp -auv build_$$opt/lib*.so* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/$$opt/; \
	done
	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl
	mv debian/tmp/usr/include/openssl/opensslconf.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl/
	mv debian/tmp/usr/include/openssl/configuration.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/openssl/

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

override_dh_fixperms:
	if [ -d debian/openssl/etc/ssl/private ] ; then \
		chmod 700 debian/openssl/etc/ssl/private ; \
	fi
	dh_fixperms -a -X etc/ssl/private

override_dh_compress:
	dh_compress
	# symlink doc files
	# We used to also add symlinks to changelog.gz but pkgstripfiles from
	# pkgbinarymangler will remove the real changelog.gz file and break all the
	# symlinks. Ignore changelog, it will end up as wanted.
	# NB: pkgstripfiles is not done in PPAs
	for p in openssl libssl-dev; do \
	  for f in changelog.Debian.gz copyright; do \
	    ln -sf ../$(library_package)/$$f debian/$$p/usr/share/doc/$$p/$$f; \
	  done; \
	done

override_dh_perl:
	dh_perl -d

override_dh_makeshlibs:
	dh_makeshlibs -a -V --add-udeb="libcrypto3-udeb" -Xengines -Xossl-modules -- -c4

override_dh_shlibdeps:
	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/$(library_package)/DEBIAN/shlibs
	dh_shlibdeps -a -L $(library_package)

## openssl 3.4.1

=== demos/guide/Makefile ===
#
# To run the demos when linked with a shared library (default) ensure that
# libcrypto and libssl are on the library path. For example:
#
#    LD_LIBRARY_PATH=../.. ./tls-client-block www.example.com 443

TESTS = tls-client-block \
        tls-server-block \
        quic-client-block \
        quic-multi-stream \
        tls-client-non-block \
        quic-client-non-block

CFLAGS  = -I../../include -g -Wall
LDFLAGS = -L../..
LDLIBS  = -lcrypto -lssl

all: $(TESTS) chain

tls-client-block: tls-client-block.o
tls-server-block: tls-server-block.o
quic-client-block: quic-client-block.o
quic-multi-stream: quic-multi-stream.o
tls-client-non-block: tls-client-non-block.o
quic-client-non-block: quic-client-non-block.o

chain: chain.pem
pkey.pem:
	openssl genpkey -algorithm rsa -out pkey.pem -pkeyopt rsa_keygen_bits:2048
chain.pem: pkey.pem
	openssl req -x509 -new -key pkey.pem -days 36500 -subj / -out chain.pem

$(TESTS):
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

clean:
	$(RM) $(TESTS) *.o

.PHONY: test chain
test: all
	@echo "\nTLS and QUIC tests:"
	@echo "skipped"

=== debian/changelog ===
openssl (3.4.1-1ubuntu4) plucky-security; urgency=medium

  * SECURITY UPDATE: Out-of-bounds read & write in RFC 3211 KEK Unwrap
    - debian/patches/CVE-2025-9230.patch: fix incorrect check of unwrapped
      key size in crypto/cms/cms_pwri.c.
    - CVE-2025-9230
  * SECURITY UPDATE: Timing side-channel in SM2 algorithm on 64 bit ARM
    - debian/patches/CVE-2025-9231-1.patch: use constant time modular
      inversion in crypto/ec/ecp_sm2p256.c.
    - debian/patches/CVE-2025-9231-2.patch: remove unused code in
      crypto/ec/ecp_sm2p256.c.
    - CVE-2025-9231
  * SECURITY UPDATE: Out-of-bounds read in HTTP client no_proxy handling
    - debian/patches/CVE-2025-9232.patch: add missing terminating NUL byte
      in crypto/http/http_lib.c.
    - CVE-2025-9232

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 18 Sep 2025 07:07:45 -0400

openssl (3.4.1-1ubuntu3) plucky; urgency=medium

  * Cherry-pick additional 3.4 fixes up to April 2:
    - post-3.4.1/*: refresh and add new upstream patches from git

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 03 Apr 2025 10:48:37 +0200

openssl (3.4.1-1ubuntu2) plucky; urgency=medium

  * Pull patches between 3.4.1 and 2025/02/17:
    - post-3.4.1/*: add upstream patches from git
    - SPARC-assembly-Don-t-file-aes-cbc-on-T4-with-small-sizes.patch:
      remove as it's included in the upstream patches

 -- Adrien Nader <adrien.nader@canonical.com>  Tue, 18 Mar 2025 10:07:41 +0100

openssl (3.4.1-1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Use perl:native in the autopkgtest for installability on i386.
    - Symlink copyright/changelog.Debian.gz in libssl3* to libssl-dev/openssl
    - Disable LTO with which the codebase is generally incompatible (LP: #2058017)
    - Default config reads crypto-config and /etc/ssl/openssl.cnf.d dropins
    - Don't enable or package anything FIPS (LP: #2087955)
    - patch: crypto: Add kernel FIPS mode detection
    - patch: crypto: Automatically use the FIPS provider...
    - patch: apps/speed: Omit unavailable algorithms in FIPS mode
    - patch: apps: pass -propquery arg to the libctx DRBG fetches
    - patch: test: Ensure encoding runs with the correct context...
    - patch: Add Ubuntu-specific defines to help FIPS certification (LP: #2073991)
      + UBUNTU_OSSL_SELF_TEST_DESC_PCT_DH
      + UBUNTU_OSSL_PROV_FIPS_PARAM_UNAPPROVED_USAGE
  * Remove now-unneeded work-around for m2crypto as discussed in #1091133
  * patch: add CPACF instruction usage for AES-XTS (LP: #2096810)

 -- Adrien Nader <adrien.nader@canonical.com>  Wed, 12 Feb 2025 10:21:22 +0100

openssl (3.4.1-1) unstable; urgency=medium

  * Import 3.4.1
  - CVE-2024-12797 (RFC7250 handshakes with unauthenticated servers don't
    abort as expected) (Closes: #1095765).
  - CVE-2024-13176 (Timing side-channel in ECDSA signature computation)
    (Closes: #1094027).
  - Compile on LoongArch again (Closes: #1092307).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 11 Feb 2025 21:30:30 +0100

openssl (3.4.0-2) unstable; urgency=medium

  * Disable padlockeng on non-x86 architectures.
  * Upload to unstable.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Mon, 06 Jan 2025 19:01:42 +0100

=== debian/control ===
Source: openssl
Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.22.5), libzstd-dev, zlib1g-dev
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OpenSSL Team <pkg-openssl-devel@alioth-lists.debian.net>
Uploaders: Christoph Martin <christoph.martin@uni-mainz.de>, Kurt Roeckx <kurt@roeckx.be>, Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/openssl
Vcs-Git: https://salsa.debian.org/debian/openssl.git
Homepage: https://www.openssl.org/
Rules-Requires-Root: no

Package: openssl
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}
Suggests: ca-certificates
Description: Secure Sockets Layer toolkit - cryptographic utility
 This package is part of the OpenSSL project's implementation of the SSL
 and TLS cryptographic protocols for secure communication over the
 Internet.
 .
 It contains the general-purpose command line binary /usr/bin/openssl,
 useful for cryptographic operations such as:
  * creating RSA, DH, and DSA key parameters;
  * creating X.509 certificates, CSRs, and CRLs;
  * calculating message digests;
  * encrypting and decrypting with ciphers;
  * testing SSL/TLS clients and servers;
  * handling S/MIME signed or encrypted mail.

Package: openssl-provider-legacy
Architecture: any
Multi-Arch: foreign
Breaks: libssl3t64 (<<3.3.1-5), libssl3 (<<3.3.1-5)
Replaces: libssl3t64 (<<3.3.1-5), libssl3 (<<3.3.1-5)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure Sockets Layer toolkit - cryptographic utility
 This package is part of the OpenSSL project's implementation of the SSL
 and TLS cryptographic protocols for secure communication over the
 Internet.
 .
 This package contains the legacy provider. The OpenSSL legacy provider
 supplies OpenSSL implementations of algorithms that have been deemed legacy.
 Such algorithms have commonly fallen out of use, have been deemed insecure by
 the cryptography community, or something similar.
 For details see OSSL_PROVIDER-legacy man page.

Package: libssl3t64
Provides: ${t64:Provides}
Replaces: libssl3
Section: libs
Architecture: any
Multi-Arch: same
Breaks: libssl3 (<< ${source:Version}), openssh-client (<< 1:9.4p1), openssh-server (<< 1:9.4p1), python3-m2crypto (<< 0.38.0-4)
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, openssl-provider-legacy
Description: Secure Sockets Layer toolkit - shared libraries
 This package is part of the OpenSSL project's implementation of the SSL
 and TLS cryptographic protocols for secure communication over the
 Internet.
 .
 It provides the libssl and libcrypto shared libraries.

Package: libcrypto3-udeb
Package-Type: udeb
Build-Profiles: <!noudeb>
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure Sockets Layer toolkit - libcrypto udeb
 This package is part of the OpenSSL project's implementation of the SSL
 and TLS cryptographic protocols for secure communication over the
 Internet.
 .
 It contains a version of the libcrypto shared library for use with the
 Debian Installer. Do not install it on a normal system.

Package: libssl3-udeb
Package-Type: udeb
Build-Profiles: <!noudeb>
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ssl shared library - udeb
 libssl shared library.
 .
 Do not install it on a normal system.

Package: libssl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Suggests: libssl-doc
Depends: libssl3t64 (= ${binary:Version}), ${misc:Depends}
Description: Secure Sockets Layer toolkit - development files
 This package is part of the OpenSSL project's implementation of the SSL
 and TLS cryptographic protocols for secure communication over the
 Internet.
 .
 It contains development libraries, header files, and manpages for libssl
 and libcrypto.

Package: libssl-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Secure Sockets Layer toolkit - development documentation
 This package is part of the OpenSSL project's implementation of the SSL
 and TLS cryptographic protocols for secure communication over the
 Internet.
 .
 It contains manpages and demo files for libssl and libcrypto.

=== debian/rules ===
--- 
+++ 
@@ -44,6 +44,10 @@
 
 ifneq ($(filter amd64 arm64 ppc64el riscv64,$(DEB_HOST_ARCH_CPU)),)
 	CONFARGS += enable-ec_nistp_64_gcc_128
+endif
+
+ifeq ($(filter amd64 i386,$(DEB_HOST_ARCH_CPU)),)
+	CONFARGS += no-padlockeng
 endif
 
 %:

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ https://openssl-library.org/source/ https://github.com/openssl/openssl/releases/download/.*openssl-(3.4.*).tar.gz

## openssl 3.5.0

=== debian/changelog ===
openssl (3.5.0-3) experimental; urgency=medium

  * Update to a git snapshot from the 3.5 branch (28a0b9c7974cd ("speed:
    Increase MAX_SIG_NUM and fix its usage in loopargs_t fields")).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sun, 29 Jun 2025 14:14:37 +0200

openssl (3.5.0-2) unstable; urgency=medium

  * Fix P-384 curve on lower-than-P9 PPC64 targets Closes: #1106516).
  * CVE-2025-4575 ("The x509 application adds trusted use instead of
    rejected use") (Closes: #1106322).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 28 May 2025 22:13:00 +0200

openssl (3.5.0-1) unstable; urgency=medium

  * Import 3.5.0
  * Upload to unstable.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 08 Apr 2025 21:15:30 +0200

openssl (3.5.0~~beta1-1) experimental; urgency=medium

  * Import 3.5.0-beta1.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 26 Mar 2025 21:38:19 +0100

openssl (3.5.0~~alpha1-1) experimental; urgency=medium

  * Import 3.5.0-alpha1.
  * Remove usr/share/doc/libssl3 (Closes: #1098515).

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 12 Mar 2025 22:08:55 +0100

## openssl 3.5.1

=== demos/encode/Makefile ===
#
# To run the demos when linked with a shared library (default) ensure
# that libcrypto is on the library path.  For example:
#
#    LD_LIBRARY_PATH=../.. ./rsa_encode

TESTS = ec_encode \
        rsa_encode

CFLAGS  = -I../../include -g -Wall
LDFLAGS = -L../..
LDLIBS  = -lcrypto

all: $(TESTS)

ec_encode: ec_encode.o
rsa_encode: rsa_encode.o

$(TESTS):
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

clean:
	$(RM) *.o $(TESTS)

.PHONY: test
test: all
	@echo "\nencode tests:"
	@echo "skipped"

=== demos/guide/Makefile ===
--- 
+++ 
@@ -9,6 +9,8 @@
         quic-client-block \
         quic-multi-stream \
         tls-client-non-block \
+        quic-server-block \
+        quic-server-non-block \
         quic-client-non-block
 
 CFLAGS  = -I../../include -g -Wall
@@ -22,13 +24,15 @@
 quic-client-block: quic-client-block.o
 quic-multi-stream: quic-multi-stream.o
 tls-client-non-block: tls-client-non-block.o
+quic-server-block: quic-server-block.o
+quic-server-non-block: quic-server-non-block.o
 quic-client-non-block: quic-client-non-block.o
 
 chain: chain.pem
 pkey.pem:
 	openssl genpkey -algorithm rsa -out pkey.pem -pkeyopt rsa_keygen_bits:2048
 chain.pem: pkey.pem
-	openssl req -x509 -new -key pkey.pem -days 36500 -subj / -out chain.pem
+	openssl req -x509 -new -key pkey.pem -days 36500 -subj '/CN=localhost' -out chain.pem
 
 $(TESTS):
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

=== demos/mac/Makefile ===
#
# To run the demos when linked with a shared library (default) ensure
# that libcrypto is on the library path. For example:
#
#    LD_LIBRARY_PATH=../.. ./gmac

TESTS = gmac \
        hmac-sha512 \
        cmac-aes256 \
        poly1305

CFLAGS  = -I../../include -g -Wall
LDFLAGS = -L../..
LDLIBS  = -lcrypto

all: $(TESTS)

gmac: gmac.o
hmac-sha512: hmac-sha512.o
cmac-aes256: cmac-aes256.o
poly1305: poly1305.o

$(TESTS):
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

clean:
	$(RM) *.o $(TESTS)

.PHONY: test
test: all
	@echo "\nMAC tests:"
	@set -e; for tst in $(TESTS); do \
		echo "\n"$$tst; \
		LD_LIBRARY_PATH=../.. ./$$tst; \
	done

=== debian/changelog ===
openssl (3.5.1-1) unstable; urgency=medium

  * Import 3.5.1

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sat, 12 Jul 2025 18:49:06 +0200

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,12 @@
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.22.5), libzstd-dev, zlib1g-dev
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OpenSSL Team <pkg-openssl-devel@alioth-lists.debian.net>
+Maintainer: Debian OpenSSL Team <pkg-openssl-devel@alioth-lists.debian.net>
 Uploaders: Christoph Martin <christoph.martin@uni-mainz.de>, Kurt Roeckx <kurt@roeckx.be>, Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/openssl
 Vcs-Git: https://salsa.debian.org/debian/openssl.git
-Homepage: https://www.openssl.org/
+Homepage: https://openssl-library.org
 Rules-Requires-Root: no
 
 Package: openssl
@@ -46,6 +45,22 @@
  Such algorithms have commonly fallen out of use, have been deemed insecure by
  the cryptography community, or something similar.
  For details see OSSL_PROVIDER-legacy man page.
+
+Package: openssl-provider-fips
+Architecture: any
+Multi-Arch: foreign
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: Secure Sockets Layer toolkit - cryptographic utility
+ This package is part of the OpenSSL project's implementation of the SSL
+ and TLS cryptographic protocols for secure communication over the
+ Internet.
+ .
+ This package contains the FIPS provider. The OpenSSL FIPS provider is a
+ special provider that conforms to the Federal Information Processing Standards
+ (FIPS) specified in FIPS 140-2. This 'module' contains an approved set of
+ cryptographic algorithms that is validated by an accredited testing
+ laboratory.
+ For details see OSSL_PROVIDER-fips and fips_module man page.
 
 Package: libssl3t64
 Provides: ${t64:Provides}

## openssl 3.5.2

=== debian/changelog ===
openssl (3.5.2-1ubuntu1) questing; urgency=medium

   * Merge with Debian unstable (LP: #2121799). Remaining changes:
    - Use perl:native in the autopkgtest for installability on i386.
    - Symlink copyright/changelog.Debian.gz in libssl3* to libssl-dev/openssl
    - Disable LTO with which the codebase is generally incompatible (LP #2058017)
    - Default config reads crypto-config and /etc/ssl/openssl.cnf.d dropins
    - Don't enable or package anything FIPS (LP #2087955)
    - fips patches (debian/patches/fips):
      - crypto: Add kernel FIPS mode detection
      - crypto: Automatically use the FIPS provider...
      - apps/speed: Omit unavailable algorithms in FIPS mode
      - apps: pass -propquery arg to the libctx DRBG fetches
      - test: Ensure encoding runs with the correct context...
      - Add Ubuntu-specific defines to help FIPS certification (LP #2073991)
        + UBUNTU_OSSL_SELF_TEST_DESC_PCT_DH
        + UBUNTU_OSSL_PROV_FIPS_PARAM_UNAPPROVED_USAGE
  * Patches refresh
    - d/p/fips/two-defines-for-fips-in-libssl-dev-headers.patch

 -- Ravi Kant Sharma <ravi.kant.sharma@canonical.com>  Mon, 01 Sep 2025 15:47:30 +0200

openssl (3.5.2-1) unstable; urgency=medium

  * Import 3.5.2

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sun, 10 Aug 2025 11:30:37 +0200

openssl (3.5.0-2ubuntu1) questing; urgency=medium

   * Merge with Debian unstable (LP: #2112457). Remaining changes:
    - Use perl:native in the autopkgtest for installability on i386.
    - Symlink copyright/changelog.Debian.gz in libssl3* to libssl-dev/openssl
    - Disable LTO with which the codebase is generally incompatible (LP #2058017)
    - Default config reads crypto-config and /etc/ssl/openssl.cnf.d dropins
    - Don't enable or package anything FIPS (LP #2087955)
    - fips patches (debian/patches/fips):
      - crypto: Add kernel FIPS mode detection
      - crypto: Automatically use the FIPS provider...
      - apps/speed: Omit unavailable algorithms in FIPS mode
      - apps: pass -propquery arg to the libctx DRBG fetches
      - test: Ensure encoding runs with the correct context...
      - Add Ubuntu-specific defines to help FIPS certification (LP #2073991)
        + UBUNTU_OSSL_SELF_TEST_DESC_PCT_DH
        + UBUNTU_OSSL_PROV_FIPS_PARAM_UNAPPROVED_USAGE
  * Patches refresh
    - d/p/fips/crypto-Automatically-use-the-FIPS-provider-when-the-kerne.patch
    - d/p/fips/two-defines-for-fips-in-libssl-dev-headers.patch
  * Dropped patch, merged upstream (LP #2096810)
    - s390x-Add-hardware-acceleration-for-full-AES-XTS.patch
  * Drop all post-3.4.1 upstream patches

 -- Ravi Kant Sharma <ravi.kant.sharma@canonical.com>  Wed, 04 Jun 2025 12:46:00 +0200

## openssl 3.5.3

=== demos/keyexch/Makefile ===
#
# To run the demos when linked with a shared library (default) ensure
# that libcrypto is on the library path. For example:
#
#    LD_LIBRARY_PATH=../.. ./x25519

TESTS = x25519 ecdh

CFLAGS  = -I../../include -g -Wall
LDFLAGS = -L../..
LDLIBS  = -lcrypto

all: $(TESTS)

x25519: x25519.o
ecdh: ecdh.o

$(TESTS):
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

clean:
	$(RM) *.o $(TESTS)

.PHONY: test
test: all
	@echo "\nKeyExchange tests:"
	@set -e; for tst in $(TESTS); do \
		echo "\n"$$tst; \
		LD_LIBRARY_PATH=../.. ./$$tst; \
	done

=== debian/changelog ===
openssl (3.5.3-1ubuntu2) questing; urgency=medium

  * SECURITY UPDATE: Out-of-bounds read & write in RFC 3211 KEK Unwrap
    - debian/patches/CVE-2025-9230.patch: fix incorrect check of unwrapped
      key size in crypto/cms/cms_pwri.c.
    - CVE-2025-9230
  * SECURITY UPDATE: Timing side-channel in SM2 algorithm on 64 bit ARM
    - debian/patches/CVE-2025-9231-1.patch: use constant time modular
      inversion in crypto/ec/ecp_sm2p256.c.
    - debian/patches/CVE-2025-9231-2.patch: remove unused code in
      crypto/ec/ecp_sm2p256.c.
    - CVE-2025-9231
  * SECURITY UPDATE: Out-of-bounds read in HTTP client no_proxy handling
    - debian/patches/CVE-2025-9232.patch: add missing terminating NUL byte
      in crypto/http/http_lib.c.
    - CVE-2025-9232

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Tue, 30 Sep 2025 16:17:50 -0230

openssl (3.5.3-1ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2125443). Remaining changes:
    - Use perl:native in the autopkgtest for installability on i386.
    - Symlink copyright/changelog.Debian.gz in libssl3* to libssl-dev/openssl
    - Disable LTO with which the codebase is generally incompatible (LP #2058017)
    - Default config reads crypto-config and /etc/ssl/openssl.cnf.d dropins
    - Don't enable or package anything FIPS (LP #2087955)
    - fips patches (debian/patches/fips):
      - crypto: Add kernel FIPS mode detection
      - crypto: Automatically use the FIPS provider...
      - apps/speed: Omit unavailable algorithms in FIPS mode
      - apps: pass -propquery arg to the libctx DRBG fetches
      - test: Ensure encoding runs with the correct context...
      - Add Ubuntu-specific defines to help FIPS certification (LP #2073991)
        + UBUNTU_OSSL_SELF_TEST_DESC_PCT_DH
        + UBUNTU_OSSL_PROV_FIPS_PARAM_UNAPPROVED_USAGE

 -- Ravi Kant Sharma <ravi.kant.sharma@canonical.com>  Mon, 22 Sep 2025 22:35:44 +0200

openssl (3.5.3-1) unstable; urgency=medium

  * Import 3.5.3
  * Drop pic & Bsymbolic patches. This shouldn't be needed anymore.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 17 Sep 2025 21:39:04 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.22.5), libzstd-dev, zlib1g-dev
 Section: utils
 Priority: optional
-Maintainer: Debian OpenSSL Team <pkg-openssl-devel@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OpenSSL Team <pkg-openssl-devel@alioth-lists.debian.net>
 Uploaders: Christoph Martin <christoph.martin@uni-mainz.de>, Kurt Roeckx <kurt@roeckx.be>, Sebastian Andrzej Siewior <sebastian@breakpoint.cc>
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/openssl
@@ -45,22 +46,6 @@
  Such algorithms have commonly fallen out of use, have been deemed insecure by
  the cryptography community, or something similar.
  For details see OSSL_PROVIDER-legacy man page.
-
-Package: openssl-provider-fips
-Architecture: any
-Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: Secure Sockets Layer toolkit - cryptographic utility
- This package is part of the OpenSSL project's implementation of the SSL
- and TLS cryptographic protocols for secure communication over the
- Internet.
- .
- This package contains the FIPS provider. The OpenSSL FIPS provider is a
- special provider that conforms to the Federal Information Processing Standards
- (FIPS) specified in FIPS 140-2. This 'module' contains an approved set of
- cryptographic algorithms that is validated by an accredited testing
- laboratory.
- For details see OSSL_PROVIDER-fips and fips_module man page.
 
 Package: libssl3t64
 Provides: ${t64:Provides}

## openssl 3.5.4

=== demos/http3/Makefile ===
#
# To run the demo when linked with a shared library (default) ensure that
# libcrypto and libssl are on the library path. For example:
#
#    LD_LIBRARY_PATH=../.. ./ossl-nghttp3-demo www.example.com:443

# when using gcc the below CFLAGS make sure you follow most of the rules of OpenSSL coding style.
#CFLAGS  += -I../../include -g -Wall -Wsign-compare -std=c90 -pedantic -pedantic-errors -Wno-long-long

CFLAGS  += -I../../include -g -Wall -Wsign-compare
LDFLAGS += -L../..
LDLIBS  = -lcrypto -lssl -lnghttp3

all: ossl-nghttp3-demo ossl-nghttp3-demo-server

ossl-nghttp3-demo: ossl-nghttp3-demo.o ossl-nghttp3.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)

ossl-nghttp3-demo-server: ossl-nghttp3-demo-server.o ossl-nghttp3.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)

clean:
	$(RM) ossl-nghttp3-demo ossl-nghttp3-demo-server *.o

.PHONY: test
test: all
	@echo "\nHTTP/3 tests:"
	@echo "skipped"

=== demos/kdf/Makefile ===
#
# To run the demos when linked with a shared library (default) ensure that
# libcrypto is on the library path. For example:
#
#    LD_LIBRARY_PATH=../.. ./hkdf

TESTS = hkdf \
        pbkdf2 \
        scrypt \
        argon2

CFLAGS  = -I../../include -g -Wall
LDFLAGS = -L../..
LDLIBS  = -lcrypto

all: $(TESTS)

hkdf: hkdf.o
pbkdf2: pbkdf2.o
scrypt: scrypt.o
argon2: argon2.o

$(TESTS):
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

clean:
	$(RM) *.o $(TESTS)

.PHONY: test
test: all
	@echo "\nKDF tests:"
	@set -e; for tst in $(TESTS); do \
		echo "\n"$$tst; \
		LD_LIBRARY_PATH=../.. ./$$tst; \
	done

=== demos/pkey/Makefile ===
#
# To run the demos when linked with a shared library (default) ensure that
# libcrypto is on the library path. For example:
#
#    LD_LIBRARY_PATH=../.. ./EVP_PKEY_EC_keygen

TESTS = EVP_PKEY_EC_keygen \
        EVP_PKEY_RSA_keygen \
        EVP_PKEY_DSA_keygen \
        EVP_PKEY_DSA_paramgen \
        EVP_PKEY_DSA_paramvalidate \
        EVP_PKEY_DSA_paramfromdata

CFLAGS  = -I../../include -g -Wall
LDFLAGS = -L../..
LDLIBS  = -lcrypto

all: $(TESTS)

EVP_PKEY_DSA_keygen.o: EVP_PKEY_DSA_keygen.c dsa.inc
EVP_PKEY_DSA_paramgen.o: EVP_PKEY_DSA_paramgen.c dsa.inc
EVP_PKEY_DSA_paramvalidate.o: EVP_PKEY_DSA_paramvalidate.c dsa.inc
EVP_PKEY_DSA_paramfromdata.o: EVP_PKEY_DSA_paramfromdata.c dsa.inc

EVP_PKEY_EC_keygen: EVP_PKEY_EC_keygen.o
EVP_PKEY_RSA_keygen: EVP_PKEY_RSA_keygen.o
EVP_PKEY_DSA_keygen: EVP_PKEY_DSA_keygen.o
EVP_PKEY_DSA_paramgen: EVP_PKEY_DSA_paramgen.o
EVP_PKEY_DSA_paramvalidate: EVP_PKEY_DSA_paramvalidate.o
EVP_PKEY_DSA_paramfromdata: EVP_PKEY_DSA_paramfromdata.o

$(TESTS):
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

clean:
	$(RM) *.o $(TESTS)

.PHONY: test
test: all
	@echo "\nPKEY tests:"
	@set -e; for tst in $(TESTS); do \
		echo "\n"$$tst; \
		LD_LIBRARY_PATH=../.. ./$$tst; \
	done

=== demos/sslecho/Makefile ===
#
# To run the demos when linked with a shared library (default) ensure that
# libcrypto and libssl are on the library path. For example:
#
#    LD_LIBRARY_PATH=../.. ./sslecho

TESTS = sslecho

CFLAGS  = -I../../include -g -Wall
LDFLAGS = -L../..
LDLIBS  = -lssl -lcrypto

all: $(TESTS)

sslecho: main.o

$(TESTS):
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

clean:
	$(RM) $(TESTS) *.o

test: all
	@echo "\nSSL Echo tests:"
	@echo "skipped"

=== doc/designs/ddd/Makefile ===
#
# To run the demos when linked with a shared library (default) ensure that
# libcrypto and libssl are on the library path. For example to run the
# ddd-01-conn-blocking-tls demo:
#
#    LD_LIBRARY_PATH=../../.. ./ddd-01-conn-blocking-tls
#
# Building ddd-06-mem-uv-tls and ddd-06-mem-uv-quic requires the
# library libuv and header file.  On Ubuntu, they are provided by the
# package "libuv1-dev".

TESTS_BASE = ddd-01-conn-blocking \
             ddd-02-conn-nonblocking \
             ddd-02-conn-nonblocking-threads \
             ddd-03-fd-blocking \
             ddd-04-fd-nonblocking \
             ddd-05-mem-nonblocking \
             ddd-06-mem-uv

TESTS = $(foreach x,$(TESTS_BASE),$(x)-tls $(x)-quic)

CFLAGS  = -I../../../include -g -Wall -Wsign-compare
LDFLAGS = -L../../..
LDLIBS  = -lcrypto -lssl

CC_CMD = $(CC) $(CFLAGS) $(LDFLAGS) -o "$@" "$<" $(LDLIBS)

all: $(TESTS)

clean:
	rm -f $(TESTS) *.o

ddd-%-tls: ddd-%.c
	$(CC_CMD)

ddd-%-quic: ddd-%.c
	$(CC_CMD) -DUSE_QUIC

ddd-%-uv-tls: ddd-%-uv.c
	$(CC_CMD) -luv

ddd-%-uv-quic: ddd-%-uv.c
	$(CC_CMD) -luv -DUSE_QUIC

=== debian/changelog ===
openssl (3.5.4-1) unstable; urgency=medium

  * Import 3.5.4
   - CVE-2025-9230 (Out-of-bounds read & write in RFC 3211 KEK Unwrap)
   - CVE-2025-9231 (Timing side-channel in SM2 algorithm on 64 bit ARM)
   - CVE-2025-9232 (Out-of-bounds read in HTTP client no_proxy handling)

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 30 Sep 2025 21:54:39 +0200

=== debian/rules ===
--- 
+++ 
@@ -11,12 +11,11 @@
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs optimize=-lto
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs
 
 SHELL=/bin/bash
 
 package=openssl
-library_package=libssl3t64
 
 # For generating the manpages
 export VERSION=$(DEB_VERSION_UPSTREAM)
@@ -31,7 +30,7 @@
 endif
 
 CONFARGS  = --prefix=/usr --openssldir=/usr/lib/ssl --libdir=lib/$(DEB_HOST_MULTIARCH) no-idea no-mdc2 no-rc5 no-ssl3 enable-unit-test no-ssl3-method enable-rfc3779 enable-cms no-capieng no-rdrand \
-	    enable-tfo enable-zstd enable-zlib no-fips
+	    enable-tfo enable-zstd enable-zlib enable-fips
 #OPT_alpha = ev4 ev5
 ARCHOPTS  = OPT_$(DEB_HOST_ARCH)
 OPTS      = $($(ARCHOPTS))
@@ -147,19 +146,6 @@
 	fi
 	dh_fixperms -a -X etc/ssl/private
 
-override_dh_compress:
-	dh_compress
-	# symlink doc files
-	# We used to also add symlinks to changelog.gz but pkgstripfiles from
-	# pkgbinarymangler will remove the real changelog.gz file and break all the
-	# symlinks. Ignore changelog, it will end up as wanted.
-	# NB: pkgstripfiles is not done in PPAs
-	for p in openssl libssl-dev; do \
-	  for f in changelog.Debian.gz copyright; do \
-	    ln -sf ../$(library_package)/$$f debian/$$p/usr/share/doc/$$p/$$f; \
-	  done; \
-	done
-
 override_dh_perl:
 	dh_perl -d
 
@@ -167,5 +153,5 @@
 	dh_makeshlibs -a -V --add-udeb="libcrypto3-udeb" -Xengines -Xossl-modules -- -c4
 
 override_dh_shlibdeps:
-	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/$(library_package)/DEBIAN/shlibs
-	dh_shlibdeps -a -L $(library_package)
+	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/libssl3t64/DEBIAN/shlibs
+	dh_shlibdeps -a -L libssl3t64

=== debian/tests/control ===
Tests: run-25-test-verify
Depends: openssl, perl
Restrictions: rw-build-tree, allow-stderr

## openssl 3.5.5

=== debian/changelog ===
openssl (3.5.5-1ubuntu1) resolute; urgency=medium

  [ Eric Berry ]
  * Enable CPU jitter fluctuations
  * Detect FIPS jitterentropy mode and load jitterentropy enabled FIPS
    provider (LP: #2141941)

  [ Ravi Kant Sharma ]
  * Merge with Debian unstable (LP: #2141708). Remaining changes:
    - d/p/regex_match_ecp_nistp521-ppc64.patch
    - Use perl:native in the autopkgtest for installability on i386.
    - Symlink copyright/changelog.Debian.gz in libssl3* to libssl-dev/openssl
    - Disable LTO with which the codebase is generally incompatible
      (LP #2058017)
    - Default config reads crypto-config and /etc/ssl/openssl.cnf.d dropins
    - Don't enable or package anything FIPS (LP #2087955)
    - Match last filename for output in ecp_nistp521-ppc64.pl (LP #2137464)
    - Enable CPU jitter fluctuations
    - fips patches (debian/patches/fips):
      - crypto: Add kernel FIPS mode detection
      - crypto: Automatically use the FIPS provider...
      - apps/speed: Omit unavailable algorithms in FIPS mode
      - apps: pass -propquery arg to the libctx DRBG fetches
      - test: Ensure encoding runs with the correct context...
      - Add Ubuntu-specific defines to help FIPS certification (LP #2073991)
        + UBUNTU_OSSL_SELF_TEST_DESC_PCT_DH
        + UBUNTU_OSSL_PROV_FIPS_PARAM_UNAPPROVED_USAGE
      - Detect FIPS jitterentropy mode and load jitterentropy enabled FIPS
        provider
  * Refreshed patches
    - fips/test-Ensure-encoding-runs-with-the-correct-context-during.patch
    - fips/two-defines-for-fips-in-libssl-dev-headers.patch
    - fips/crypto-Automatically-use-the-FIPS-provider-when-the-kerne.patch

 -- Ravi Kant Sharma <ravi.kant.sharma@canonical.com>  Sun, 15 Feb 2026 14:56:21 +0100

openssl (3.5.5-1) unstable; urgency=medium

  * Import 3.5.5
   - CVE-2025-11187 (Improper validation of PBMAC1 parameters in PKCS#12 MAC
     verification)
   - CVE-2025-15467 (Stack buffer overflow in CMS AuthEnvelopedData parsing)
   - CVE-2025-15468 (NULL dereference in SSL_CIPHER_find() function on unknown
     cipher ID)
   - CVE-2025-15469 ("openssl dgst" one-shot codepath silently truncates inputs
     >16MB)
   - CVE-2025-66199 (TLS 1.3 CompressedCertificate excessive memory allocation)
   - CVE-2025-68160 (Heap out-of-bounds write in BIO_f_linebuffer on short
     writes)
   - CVE-2025-69418 (Unauthenticated/unencrypted trailing bytes with low-level
     OCB function calls)
   - CVE-2025-69419 (Out of bounds write in PKCS12_get_friendlyname() UTF-8
     conversion)
   - CVE-2025-69420 (Missing ASN1_TYPE validation in TS_RESP_verify_response()
     function)
   - CVE-2025-69421 (NULL Pointer Dereference in PKCS12_item_decrypt_d2i_ex
     function)
   - CVE-2026-22795 (Missing ASN1_TYPE validation in PKCS#12 parsing)
   - CVE-2026-22796 (ASN1_TYPE Type Confusion in the
   - PKCS7_digest_from_attributes() function)

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 27 Jan 2026 21:09:55 +0100

openssl (3.5.4-1ubuntu1) resolute; urgency=medium

  * Match last filename for output in ecp_nistp521-ppc64.pl (LP: #2137464)
    - d/p/regex_match_ecp_nistp521-ppc64.patch
  * Drop patches, merged upstream
    - d/p/CVE-2025-9230.patch
    - d/p/CVE-2025-9231-1.patch
    - d/p/CVE-2025-9231-2.patch
    - d/p/CVE-2025-9232.patch 
  * Merge with Debian unstable (LP: #2133492). Remaining changes:
    - Use perl:native in the autopkgtest for installability on i386.
    - Symlink copyright/changelog.Debian.gz in libssl3* to libssl-dev/openssl
    - Disable LTO with which the codebase is generally incompatible (LP #2058017)
    - Default config reads crypto-config and /etc/ssl/openssl.cnf.d dropins
    - Don't enable or package anything FIPS (LP #2087955)
    - Match last filename for output in ecp_nistp521-ppc64.pl (LP #2137464)
    - fips patches (debian/patches/fips):
      - crypto: Add kernel FIPS mode detection
      - crypto: Automatically use the FIPS provider...
      - apps/speed: Omit unavailable algorithms in FIPS mode
      - apps: pass -propquery arg to the libctx DRBG fetches
      - test: Ensure encoding runs with the correct context...
      - Add Ubuntu-specific defines to help FIPS certification (LP #2073991)
        + UBUNTU_OSSL_SELF_TEST_DESC_PCT_DH
        + UBUNTU_OSSL_PROV_FIPS_PARAM_UNAPPROVED_USAGE

 -- Ravi Kant Sharma <ravi.kant.sharma@canonical.com>  Thu, 08 Jan 2026 15:53:39 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: openssl
-Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.22.5), libzstd-dev, zlib1g-dev
+Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.22.5), libzstd-dev, zlib1g-dev, libjitterentropy3-dev
 Section: utils
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>

=== debian/rules ===
--- 
+++ 
@@ -11,11 +11,12 @@
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs optimize=-lto
 
 SHELL=/bin/bash
 
 package=openssl
+library_package=libssl3t64
 
 # For generating the manpages
 export VERSION=$(DEB_VERSION_UPSTREAM)
@@ -30,7 +31,7 @@
 endif
 
 CONFARGS  = --prefix=/usr --openssldir=/usr/lib/ssl --libdir=lib/$(DEB_HOST_MULTIARCH) no-idea no-mdc2 no-rc5 no-ssl3 enable-unit-test no-ssl3-method enable-rfc3779 enable-cms no-capieng no-rdrand \
-	    enable-tfo enable-zstd enable-zlib enable-fips
+	    enable-tfo enable-zstd enable-zlib no-fips enable-jitter
 #OPT_alpha = ev4 ev5
 ARCHOPTS  = OPT_$(DEB_HOST_ARCH)
 OPTS      = $($(ARCHOPTS))
@@ -146,6 +147,19 @@
 	fi
 	dh_fixperms -a -X etc/ssl/private
 
+override_dh_compress:
+	dh_compress
+	# symlink doc files
+	# We used to also add symlinks to changelog.gz but pkgstripfiles from
+	# pkgbinarymangler will remove the real changelog.gz file and break all the
+	# symlinks. Ignore changelog, it will end up as wanted.
+	# NB: pkgstripfiles is not done in PPAs
+	for p in openssl libssl-dev; do \
+	  for f in changelog.Debian.gz copyright; do \
+	    ln -sf ../$(library_package)/$$f debian/$$p/usr/share/doc/$$p/$$f; \
+	  done; \
+	done
+
 override_dh_perl:
 	dh_perl -d
 
@@ -153,5 +167,5 @@
 	dh_makeshlibs -a -V --add-udeb="libcrypto3-udeb" -Xengines -Xossl-modules -- -c4
 
 override_dh_shlibdeps:
-	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/libssl3t64/DEBIAN/shlibs
-	dh_shlibdeps -a -L libssl3t64
+	sed -i '/^udeb: libssl/s/libcrypto3-udeb/libssl3-udeb/' debian/$(library_package)/DEBIAN/shlibs
+	dh_shlibdeps -a -L $(library_package)

## openssl 3.6.0~~alpha1

=== debian/changelog ===
openssl (3.6.0~~alpha1-1) experimental; urgency=medium

  * Import 3.6.0-alpha1

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Sat, 06 Sep 2025 20:21:28 +0200

## openssl 3.6.0~~beta1

=== debian/changelog ===
openssl (3.6.0~~beta1-1) experimental; urgency=medium

  * Import 3.6.0-beta1
  * Drop pic & Bsymbolic patches. This shouldn't be needed anymore.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 18 Sep 2025 21:36:20 +0200

## openssl 3.6.0

=== demos/quic/poll-server/Makefile ===
#
# To run the demo when linked with a shared library (default) ensure that
# libcrypto and libssl are on the library path. For example:
#
#    LD_LIBRARY_PATH=../../.. ./server 4444 \
#    	../../../test/certs/servercert.pem \
#    	../../../test/certs/serverkey.pem
#
CFLAGS  += -I../../../include -g -Wall -Wsign-compare
LDFLAGS += -L../../..
LDLIBS  = -lcrypto -lssl

.PHONY: all server clean run s_client

all: quic-server-ssl-poll-http

quic-server-ssl-poll-http: quic-server-ssl-poll-http.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)

clean:
	$(RM) server *.o

run: quic-server-ssl-poll-http
	LD_LIBRARY_PATH=../../.. ./quic-server-ssl-poll-http 4444 \
	    ../../../test/certs/servercert.pem \
	    ../../../test/certs/serverkey.pem

=== debian/changelog ===
openssl (3.6.0-1) experimental; urgency=medium

  * Import 3.6.0
  * Stop shipping c_rehash. It bas been long replaced by "openssl rehash"

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Fri, 03 Oct 2025 17:40:10 +0200

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ https://openssl-library.org/source/ https://github.com/openssl/openssl/releases/download/.*openssl-(3.6.*).tar.gz

## openssl 3.6.1

=== debian/changelog ===
openssl (3.6.1-1) experimental; urgency=medium

  * Import 3.6.1
   - CVE-2025-11187 (Improper validation of PBMAC1 parameters in PKCS#12 MAC
     verification)
   - CVE-2025-15467 (Stack buffer overflow in CMS AuthEnvelopedData parsing)
   - CVE-2025-15468 (NULL dereference in SSL_CIPHER_find() function on unknown
     cipher ID)
   - CVE-2025-15469 ("openssl dgst" one-shot codepath silently truncates inputs
     >16MB)
   - CVE-2025-66199 (TLS 1.3 CompressedCertificate excessive memory allocation)
   - CVE-2025-68160 (Heap out-of-bounds write in BIO_f_linebuffer on short
     writes)
   - CVE-2025-69418 (Unauthenticated/unencrypted trailing bytes with low-level
     OCB function calls)
   - CVE-2025-69419 (Out of bounds write in PKCS12_get_friendlyname() UTF-8
     conversion)
   - CVE-2025-69420 (Missing ASN1_TYPE validation in TS_RESP_verify_response()
     function)
   - CVE-2025-69421 (NULL Pointer Dereference in PKCS12_item_decrypt_d2i_ex
     function)
   - CVE-2026-22795 (Missing ASN1_TYPE validation in PKCS#12 parsing)
   - CVE-2026-22796 (ASN1_TYPE Type Confusion in the
   - PKCS7_digest_from_attributes() function)

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Tue, 27 Jan 2026 21:32:02 +0100

openssl (3.6.0-2) experimental; urgency=medium

  * Apply fix for upstream issue #28902

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Fri, 26 Dec 2025 17:01:03 +0100

## openssl encrypt-1.2.0

=== requirements.txt ===
# Core dependencies
cryptography>=44.0.1,<45.0.0  # Updated to fix CVE-2024-12797
argon2-cffi>=23.1.0,<24.0.0
# does not build on python 3.13
#whirlpool>=0.3 ; python_version < '3.12'
whirlpool-py311>=1.0.0,<2.0.0 ; python_version >= '3.11'
# Windows-specific dependencies
pywin32>=306,<307; sys_platform == 'win32'
PyYAML>=6.0.2,<7.0.0

# Optional post-quantum cryptography dependencies
# liboqs-python>=0.7.0  # Uncomment to enable post-quantum cryptography support

# Development tools (commented out by default)
pytest>=8.0.0,<9.0.0
pytest-cov>=4.1.0,<5.0.0
black>=24.1.0,<25.0.0
pylint>=3.0.0,<4.0.0
